clear
close all
clc

set(0,'defaultlinelinewidth',2)
set(0,'defaultaxesfontsize',14)
set(0,'defaulttextfontsize',14)

%%%%%%%% SCRIPT POURPOSE %%%%%%%%%%

%This script can be used to produce 3D maps of the data according to
%different classification categories

%%%%%%%% SCRIPT POURPOSE %%%%%%%%%%

%%%%%%%%%%%%%%%%% CONTROL PANEL %%%%%%%%%%%%%%%%%%%%%%%%

%Suffissi da mettere al nome del file da stampare
category = '_C1';            %C1 C2 C3
data_set = '_NF';            %NF or empty
ToT = '_TEST';        %TRAINING or TEST
%%%%%%%%%%%%%%%%% CONTROL PANEL %%%%%%%%%%%%%%%%%%%%%%%%

%Name of files to read
ext_txt = '.txt';

name_sim = ['input' ToT data_set ext_txt];
name_labels = ['labels' category ToT data_set ext_txt];

category_name = [erase(category,'_') ')'];

%Name of the figure
ext_jpg = '.jpg';
path = 'C:\Users\NICAR\OneDrive\Desktop\GT_maps'; %Please change the path according to where you want to change
base_name_fig1 = '\fig_GT';
full_name_fig1 = [base_name_fig1 ToT category data_set ext_jpg];

%Full path to save both figures
wts1 = [path full_name_fig1];

%%%%%%%%% Loading the input points %%%%%%%%%%% 

fileName = name_sim;
FID = fopen(fileName);
data = textscan(FID,'%s','Delimiter',{','});
sim_codes = string(data{:});
sim_codes = reshape( sim_codes , 3 , [])';
fclose(FID);
sim_codes = str2double(sim_codes); %Convert the string matrix in a matrix of doubles

%Loading labels
fileName = name_labels; %Missing and needs to be created
FID = fopen(fileName);
data = textscan(FID,'%s','Delimiter',{'\n'});
labels = string(data{:});
fclose(FID);
labels = categorical(labels);

%%%%%%%%% End of loading %%%%%%%%%%% 

% The data to be plotted:
x = -100*sim_codes(:,1); 
y = -100*sim_codes(:,2);
z = -100*sim_codes(:,3);

%Make the legend list from the labels in input
legend_list = unique(labels);

% % RGB values of your favorite colors: 
% 
% colors = brewermap(length(uniqueGroups),'Set1'); 

% Plot the whole data - success and failures
figure(1)
view(3)
grid on
hold on
xlim([-100 0])
ylim([-100 0])
zlim([-100 0])


for kk = 1:length(legend_list)
      % Get indices of this particular unique group:
      ind = labels==legend_list(kk); 
      
      current_color = fun_choose_color(legend_list(kk),erase(category_name,')'));
      
      % Plot only this class: 
      fig1 = plot3(x(ind),y(ind),z(ind),'.','markersize',14); 
      fig1.Color = current_color;
end
legend(legend_list)
plot(0,0,'c*','MarkerSize',14,'displayname','Nominal')

xlabel('\DeltaFC flow rate (%)')
ylabel('\DeltaIC flow rate (%)')
zlabel('\DeltaGC flow rate (%)')
hold off

if string(ToT) == "_TRAINING"
    title_label = strcat('Training-set ', ' GT classification (',category_name);
else
    title_label = strcat('Test-set ', ' GT classification (',category_name); 
end

title(title_label) 

%Save fig1
saveas(fig1,wts1)




