clear
close all
clc

set(0,'defaultlinelinewidth',2)
set(0,'defaultaxesfontsize',14)
set(0,'defaulttextfontsize',14)

%%%%%%%% SCRIPT POURPOSE %%%%%%%%%%

%The purpose of this script is to plot the test set according to two
%different labels: correctly classified and missclassified

%%%%%%%% SCRIPT POURPOSE %%%%%%%%%%

%%%%%%%%%%%%%%%%% CONTROL PANEL %%%%%%%%%%%%%%%%%%%%%%%%

%Suffissi da mettere al nome del file da stampare
category = '_C1';            %C1 C2 C3
data_set = '';            %NF or empty
preprocessing = '';         %NORM1 or NORM2
%%%%%%%%%%%%%%%%% CONTROL PANEL %%%%%%%%%%%%%%%%%%%%%%%%

%Useful extentions
ext_txt = '.txt';

%Name of files to read
name_sim = ['input' '_TEST' data_set ext_txt];
name_labels_GT = ['labels' category '_TEST' data_set ext_txt];
name_labels_predictions = ['predicted_labels' category data_set ext_dat];

category_name = [erase(category,'_') ')'];

%Name of the figure
ext_jpg = '.jpg';
path = 'C:\Users\NICAR\OneDrive\Desktop'; %Please change the path according to where you want to change
base_name_fig1 = '\fig_classifier_cw';
full_name_fig1 = [base_name_fig1 category data_set ext_jpg];

%Full path to save the figures
wts1 = [path full_name_fig1];

%%%%%%%%% Loading the input points %%%%%%%%%%% 

fileName = name_sim;
FID = fopen(fileName);
data = textscan(FID,'%s','Delimiter',{','});
sim_codes = string(data{:});
sim_codes = reshape( sim_codes , 3 , [])';
fclose(FID);
sim_codes = str2double(sim_codes); %Convert the string matrix in a matrix of doubles

%Loading labels Ground Truth for the test set
fileName = name_labels_GT; %Missing and needs to be created
FID = fopen(fileName);
data = textscan(FID,'%s','Delimiter',{'\n'});
labels_GT = string(data{:});
fclose(FID);

%Loading labels PREDICTED for the TEST SET
tmp = load(name_labels_predictions);
predictions_test_labels = tmp.labels_predictions;
predictions_test_labels = string(predictions_test_labels);

%%%%%%%%% End of loading %%%%%%%%%%% 

% The data to be plotted:
x = -100*sim_codes(:,1); 
y = -100*sim_codes(:,2);
z = -100*sim_codes(:,3);

%Make the legend list from the labels in input
legend_list = unique(labels_GT);

% % RGB values of your favorite colors: 
% 
% colors = brewermap(length(uniqueGroups),'Set1'); 

% Plot the whole data - success and failures
figure(1)
view(3)
grid on
hold on
xlim([-100 0])
ylim([-100 0])
zlim([-100 0])

for kk = 1:length(legend_list)
      % Get indices of this particular unique group:
      ind = labels_GT==legend_list(kk); 
      % Plot only this class: 
      plot3(x(ind),y(ind),z(ind),'.','markersize',14); 
end
legend(legend_list)
fig1 = plot(0,0,'c*','MarkerSize',14,'displayname','Nominal')

xlabel('\DeltaFC flow rate (%)')
ylabel('\DeltaIC flow rate (%)')
zlabel('\DeltaGC flow rate (%)')
hold off
title(strcat('Test-set correct classification (',category_name)) %Manually change Training/Test

%Save fig1
saveas(fig1,wts1)