function color = fun_choose_color(current_class,cat_rule)
%This function takes in input the currently considered class and it
%associates to it a color for plotting purposes

%Make sure the current class is a string
current_class = string(current_class);

if cat_rule == 'C2' | cat_rule == 'C3'
    %Obtain the full list of possible classes
    full_list_of_possible_classes = ["Success","LT_{IC}","LT_{FC}LT_{IC}",...
        "LT_{FC}","HT_{FC}","HT_{IC}","HT_{IC}LT_{IC}","HT_{FC}LT_{FC}HT_{IC}",...
    "LT_{FC}HT_{IC}","LT_{FC}HT_{IC}LT_{IC}","HT_{FC}HT_{IC}LT_{IC}",...
    "HT_{FC}HT_{IC}","HT_{FC}LT_{FC}HT_{IC}LT_{IC}"];
    
    %Define in which position the current class is
    pos = find(current_class == full_list_of_possible_classes,1);
    
    list_of_colors = {[0 0.4470 0.7410],[0.8500 0.3250 0.0980],[0.9290 0.6940 0.1250],...
        [245, 130, 48],[240, 50, 230],...
        [255, 225, 25], [145, 30, 180], [210, 245, 60],...
        [250, 190, 212],[0, 128, 128], [220, 190, 255],[170, 110, 40], [128, 128, 0],...
        [128, 0, 0], [0, 0, 128],[0, 0, 0]};
    
    for ii = 1:numel(list_of_colors)
        
        if ismember(ii,[1 2 3])
            
        else
            
            list_of_colors{ii} = list_of_colors{ii}./255;
        end
    end
    
else
    %Obtain the full list of possible classes
    full_list_of_possible_classes = ["Success","Physical Failure","Numerical Failure"];
    
    %Define in which position the current class is
    pos = find(current_class == full_list_of_possible_classes,1);
    
    list_of_colors = {[0 0.4470 0.7410],[0.8500 0.3250 0.0980],[0.9290 0.6940 0.1250]};
    
end


%Associate the correct color to the current class
color = list_of_colors{pos};

end