function [coeff,output_basi] = fun_decomposition(Model_Out,perc_var_req1,Ntransients)
%perc_var_req1 % percentuale di variabilit del dataset che noi vogliamo "spiegare" dopo il troncamento dello sviluppo ad un numero finito (e possibilimente ridotto) di basi ortogonali

medie = mean(Model_Out,1); % Model_out contiene i transitori (Ntransients * TimeSteps) --> calcolo media dei transitori
data_reduced = Model_Out - ones(Ntransients,1)*medie; %--> sottrarre la media ai transitori
[U1, S1, V1] = svd(data_reduced); % decomposizione ai valori singolari (SVD)
coefficient_data = data_reduced*V1; % proiezione dei transitori ridotti sulle basi ortonormali --> si ottengono coefficienti indipendenti dal tempo e dipendenti solo dagli input
% le colonne di V1 (TimeSteps * TimeSteps) contengono le basi ortornormali
singval1 = diag(S1); % --> estrazione della diagonale di S1: contiene gli autovalori della decomposizione
perc_var1 = cumsum(singval1.^2)/sum(singval1.^2); % vettore che contiene la "percentuale di varianza" spiegata dagli autovalori
nbase1 = min(find(perc_var1 >= perc_var_req1)); % si tronca la decomposizione ad un numero di basi (nbase1) tali che spieghino una percentuale voluta di varianza (es. perc_var_req1 = 99%)
% % NOTA: coefficient_data(:, 1:nbase1) sono i punti nbase1-dimensionali
% che tu tenterai di classificare!

coeff = coefficient_data(:, 1:nbase1);

output_basi = V1(:,1:nbase1);

% NOTA: se per qualche motivo volessi ricostruire i transitori originali
% reconstructed_transients = coefficient_data(:, 1:nbase1)*V1(:, 1:nbase1)' + ones(Ntransients,1)*medie;

% NOTA: questa procedura va fatta per ogni variabile fisica di output!
% (ogni variabile avr il suo set di basi)

end